Subject: Re: [PATCH net v3] net: bridge: fix vlan stats use-after-free on destruction

From: Stephen Hemminger <[email-masked]>
Date: Thu, 23 Apr 2020 17:05:21 -0700

On Fri, 16 Nov 2018 18:50:01 +0200
Nikolay Aleksandrov <[email-masked]> wrote:

> Syzbot reported a use-after-free of the global vlan context on port vlan
> destruction. When I added per-port vlan stats I missed the fact that the
> global vlan context can be freed before the per-port vlan rcu callback.
> There're a few different ways to deal with this, I've chosen to add a
> new private flag that is set only when per-port stats are allocated so
> we can directly check it on destruction without dereferencing the global
> context at all. The new field in net_bridge_vlan uses a hole.
> 
> v2: cosmetic change, move the check to br_process_vlan_info where the
>     other checks are done
> v3: add change log in the patch, add private (in-kernel only) flags in a
>     hole in net_bridge_vlan struct and use that instead of mixing
>     user-space flags with private flags
> 
> Fixes: 9163a0fc1f0c ("net: bridge: add support for per-port vlan stats")
> Reported-by: [email-masked]
> Signed-off-by: Nikolay Aleksandrov <[email-masked]>

Why not just use v->stats itself as the flag.
Since free of NULL is a nop it would be cleaner?